/*
	EGX_Medevac system - by Enigx
	
	CallMedevacV2.sqf
	
*/

if (orderGoMedEGX == 1) exitWith {
	hint "Medevac is already on a mission. \nWait for it to finish before calling it again.\nOr reset the call running the Order Medevac GO command"};

orderGoMedEGX = 1;
publicVariable "orderGoMedEGX";

private ["_MedevacClass","_MedicPointMkr","_numWypInt","_MkrIntMedArray","_wpM","_wpMback","_wpM2","_wpEnd","_MkrIntMedArrayCount","_LandposExt","_cont"];	

if ((getMarkerColor "MedicPoint" == "")) exitWith {
	hint "The marker of the medical point has not been defined on map by editor.";
	orderGoMedEGX = 0; publicVariable "orderGoMedEGX";};

// Definition of the chopter type
_MedevacClass = "RHS_UH60M_MEV2"; // ====== Classname of the used Medevac. MODIFY CLASSNAME IF NEEDED

if (!(isClass (configFile >> "cfgVehicles" >> (_MedevacClass)))) exitWith {hint format["The requested RHS mod for Medevac has not been loaded."];
orderGoMedEGX = 0;publicVariable "orderGoMedEGX";};

createMarkerLocal ["ExtrPositionMark",[0,0,0]];
"ExtrPositionMark" setMarkerTypeLocal "hd_pickup";
"ExtrPositionMark" setMarkerColorLocal "ColorBlue";
createMarkerLocal ["wypInMedtMark1",[0,0,0]];
createMarkerLocal ["wypInMedtMark2",[0,0,0]];
createMarkerLocal ["wypInMedtMark3",[0,0,0]];
createMarkerLocal ["wypInMedtMark4",[0,0,0]];
_numWypInt = 4;

private _MkrIntNameArray = ["wypInMedtMark1","wypInMedtMark2","wypInMedtMark3","wypInMedtMark4"];
_MkrIntMedArray = [];

_MedicPointMkr = getMarkerPos "MedicPoint";
_MkrIntMedArray pushBack _MedicPointMkr;
sleep 0.1;

openMap true;
for "_i" from 0 to (_numWypInt-1) do {		
	mapclick = true;
	hint format["Click on intermediate waypoint %1/%2",_i+1,_numWypInt];
	gg = _MkrIntNameArray select _i;						
	onMapSingleClick {gg setMarkerPos _pos;mapclick = false;
	onMapSingleClick ''; true;};		
	
	waitUntil {!mapClick};
	(_MkrIntNameArray select _i) setMarkerTypeLocal "mil_objective";				
	_MkrIntMedArray pushBack (getMarkerPos (_MkrIntNameArray select _i));
	sleep 0.2;
};		
sleep 0.2;
mapclick = true;
hint "Click on final Medevac landing zone for injured players extraction";
onMapSingleClick """ExtrPositionMark"" setMarkerPosLocal _pos;mapclick = false;
onMapSingleClick ''; true;";
waitUntil {!mapClick};
_LandposExt = getMarkerPos "ExtrPositionMark";
sleep 1;
openMap false;
		
_cont = 0;
_centre = getMarkerPos "ExtrPositionMark";
_LandposExt = [];
_max_distance = 100;		
while{ (count _LandposExt < 1) } do
{
	_LandposExt = _centre findEmptyPosition[10, _max_distance, _MedevacClass];
	_max_distance = _max_distance + 10;
	_cont = _cont + 1;
	if (_cont == 10) exitwith {};	 
};
if (_cont == 10) exitwith {};		
createMarkerLocal ["SafeLZMd",_LandposExt];
"SafeLZMd" setMarkerPosLocal _LandposExt;
"SafeLZMd" setMarkerTypeLocal "hd_pickup";
"SafeLZMd" setMarkerColorLocal "ColorGreen";
"SafeLZMd" setMarkerTextLocal "Safe LZ";
"ExtrPositionMark" setMarkerAlphaLocal 0;
hint parsetext format["<t font='TahomaB' t size='1.25' t color='#00FF00'>Safe landing zone found close to selected position.</t>"];

if (_cont == 10) exitwith {
	hint parsetext format["<t font='TahomaB' t size='1.25' t color='#FF0000'>Safe landing zone not found! Please try again by specifying a new position.</t>"];
	deleteMarkerLocal "ExtrPositionMark";
	for "_i" from 0 to (_numWypInt-1) do {deleteMarkerLocal (_MkrIntNameArray select _i);};
	orderGoMedEGX = 0;
	publicVariable "orderGoMedEGX";			
};
_MkrIntMedArray pushBack _LandposExt;
sleep 1;		
_heliPadMed = createVehicle ["Land_HelipadEmpty_F", _LandposExt];
_heliPadMedPoint = createVehicle ["Land_HelipadEmpty_F", _MedicPointMkr];
sleep 1;
_heliMedevac = createVehicle [_MedevacClass, _MedicPointMkr,[], 0,"FLY"];
_heliMedevac flyInHeight 100;
//_heliMedevac allowdamage false; 								// ====== MODIFY, REMOVING THE COMMENT, IF NEEDED TO SET MEDEVAC INVULNERABLE

createVehicleCrew _heliMedevac;
{_x setSkill 1;} forEach (crew _heliMedevac);
_heliGrpMed = group _heliMedevac;
_MkrIntMedArrayCount = (count _MkrIntMedArray) - 1;
for "_i" from 1 to _MkrIntMedArrayCount do
{
_wpM = _heliGrpMed addWaypoint [_MkrIntMedArray select _i, 0];
_wpM setWaypointType "MOVE";
_wpM setWaypointBehaviour "CARELESS";
_wpM setWaypointCombatMode "GREEN";
_wpM setWaypointSpeed "NORMAL";
};
_wpM setWaypointStatements ["true", "(vehicle this) land 'GET IN'"];	

waituntil {getposatl _heliMedevac distance _LandposExt < 250};
createVehicle ["SmokeShell", _LandposExt,[], 0,"NONE"];

waitUntil {isTouchingGround _heliMedevac};
orderGoMedEGX = 1;
publicVariable "orderGoMedEGX";
sleep 0.2;
waitUntil {orderGoMedEGX == 0};

reverse _MkrIntMedArray;
for "_i" from 1 to _MkrIntMedArrayCount do
	{
		_wpMback = _heliGrpMed addWaypoint [_MkrIntMedArray select _i, 0];
		_wpMback setWaypointType "MOVE";
		_wpMback setWaypointBehaviour "CARELESS";
		_wpMback setWaypointCombatMode "GREEN";
		_wpMback setWaypointSpeed "NORMAL";
	};
_wpMback setWaypointStatements ["true", "(vehicle this) land 'LAND'"];
		
waitUntil {(getPosATL _heliMedevac) select 2 > 20};
sleep 10;

_imgmessMd = "<img size='5' image= 'EGX_Medevac\medevac.jpg' align='center'/><br/><br/>";
_txtMd1 = format["<t font='TahomaB' t size='1.25' t color='#FF0000'>Message for the injured players on board the Medevac:<br/></t>"];
_txtMd2 = format["<t font='TahomaB' t size='1.25' t color='#00FF00'>ONCE HEALED STAY ON BOARD, DO NOT GET OUT!<br/></t>"];
_txtMd3 = format["<t font='TahomaB' t size='1.25' t color='#00FF00'>You will be automatically transported back to operational area.<br/></t>"];
[parseText (_imgmessMd + _txtMd1 + _txtMd2 + _txtMd3)] remoteExec ["hint",0,false];
		
waitUntil {isTouchingGround _heliMedevac};
{[objNull, _x] call ace_medical_treatment_fnc_fullHeal} forEach (crew _heliMedevac);

reverse _MkrIntMedArray;
for "_i" from 1 to _MkrIntMedArrayCount do
	{
		_wpM2 = _heliGrpMed addWaypoint [_MkrIntMedArray select _i, 0];
		_wpM2 setWaypointType "MOVE";
		_wpM2 setWaypointBehaviour "CARELESS";
		_wpM2 setWaypointCombatMode "GREEN";
		_wpM2 setWaypointSpeed "NORMAL";
	};
_wpM2 setWaypointStatements ["true", "(vehicle this) land 'LAND'"];
		
waitUntil {(getPosATL _heliMedevac) select 2 > 20};
waitUntil {isTouchingGround _heliMedevac};
{if (vehicle _x == _heliMedevac) then {moveOut _x};} forEach allPlayers;
waitUntil {{!(vehicle _x == _heliMedevac);} forEach allPlayers};

reverse _MkrIntMedArray;
for "_i" from 1 to _MkrIntMedArrayCount do
	{
		_wpEnd = _heliGrpMed addWaypoint [_MkrIntMedArray select _i, 0];
		_wpEnd setWaypointType "MOVE";
		_wpEnd setWaypointBehaviour "CARELESS";
		_wpEnd setWaypointCombatMode "GREEN";
		_wpEnd setWaypointSpeed "NORMAL";
	};
_wpEnd setWaypointStatements ["true", "trasp_med = vehicle leader this; { deleteVehicle _x } forEach crew trasp_med + [trasp_med]"];
			
deleteMarkerLocal "ExtrPositionMark";
for "_i" from 0 to (_numWypInt-1) do {deleteMarkerLocal (_MkrIntNameArray select _i);};	
deleteVehicle _heliPadMed;
deleteVehicle _heliPadMedPoint;

deleteMarkerLocal "SafeLZMd";

waitUntil {!alive _heliMedevac};
hint "Call of a new Medevac ready!";	